--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
@@ -7090,7 +7428,7 @@
 		    cmp->hdr.Signature[2] != 'C' ||
 		    cmp->hdr.Signature[3] != 'M') {
 			EL(ha, "cfg_map chksum=%xh, version=%d, "
-			    "sig=%c%c%c%c\n", chksum, w16,
+			    "sig=%c%c%c%c \n", chksum, w16,
 			    cmp->hdr.Signature[0], cmp->hdr.Signature[1],
 			    cmp->hdr.Signature[2], cmp->hdr.Signature[3]);
 		} else {
@@ -7101,7 +7439,7 @@
 			for (i = 0; i < cnt; i++) {
 				if (cmp->cfg[i].FunctionType == FT_FC &&
 				    cmp->cfg[i].FunctionNumber[0] ==
-				    ha->function_number &&
+				    ha->pci_function_number &&
 				    cmp->cfg[i].FunctionNumber[1] == 0) {
 					nv_rg = cmp->cfg[i].ConfigRegion;
 					vpd_rg = cmp->cfg[i].VpdRegion;
@@ -7131,8 +7469,8 @@
 		case FLASH_8021_BOOTLOADER_REGION:
 			ha->bootloader_addr = faddr;
 			ha->bootloader_size = (fe_addr - faddr) + 1;
-			QL_PRINT_9(CE_CONT, "(%d): bootloader_addr=%xh, "
-			    "size=%xh\n", ha->instance, faddr,
+			QL_PRINT_9(ha, "bootloader_addr=%xh, "
+			    "size=%xh\n", faddr,
 			    ha->bootloader_size);
 			break;
 		case FLASH_FW_REGION:
@@ -7139,21 +7477,21 @@
 		case FLASH_8021_FW_REGION:
 			ha->flash_fw_addr = faddr;
 			ha->flash_fw_size = (fe_addr - faddr) + 1;
-			QL_PRINT_9(CE_CONT, "(%d): flash_fw_addr=%xh, "
-			    "size=%xh\n", ha->instance, faddr,
+			QL_PRINT_9(ha, "flash_fw_addr=%xh, "
+			    "size=%xh\n", faddr,
 			    ha->flash_fw_size);
 			break;
 		case FLASH_GOLDEN_FW_REGION:
 		case FLASH_8021_GOLDEN_FW_REGION:
 			ha->flash_golden_fw_addr = faddr;
-			QL_PRINT_9(CE_CONT, "(%d): flash_golden_fw_addr=%xh\n",
+			QL_PRINT_9(ha, "flash_golden_fw_addr=%xh\n",
 			    ha->instance, faddr);
 			break;
 		case FLASH_8021_VPD_REGION:
 			if (!vpd_rg || vpd_rg == FLASH_8021_VPD_REGION) {
 				ha->flash_vpd_addr = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): 8021_flash_vpd_"
-				    "addr=%xh\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "8021_flash_vpd_"
+				    "addr=%xh\n", faddr);
 			}
 			break;
 		case FLASH_VPD_0_REGION:
@@ -7160,15 +7498,15 @@
 			if (vpd_rg) {
 				if (vpd_rg == FLASH_VPD_0_REGION) {
 					ha->flash_vpd_addr = faddr;
-					QL_PRINT_9(CE_CONT, "(%d): vpd_rg  "
+					QL_PRINT_9(ha, "vpd_rg  "
 					    "flash_vpd_addr=%xh\n",
 					    ha->instance, faddr);
 				}
-			} else if (!(ha->flags & FUNCTION_1) &&
-			    !(CFG_IST(ha, CFG_CTRL_8021))) {
+			} else if (ha->function_number == 0 &&
+			    !(CFG_IST(ha, CFG_CTRL_82XX))) {
 				ha->flash_vpd_addr = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_vpd_addr=%xh"
-				    "\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_vpd_addr=%xh"
+				    "\n", faddr);
 			}
 			break;
 		case FLASH_NVRAM_0_REGION:
@@ -7175,17 +7513,17 @@
 			if (nv_rg) {
 				if (nv_rg == FLASH_NVRAM_0_REGION) {
 					ADAPTER_STATE_LOCK(ha);
-					ha->flags &= ~FUNCTION_1;
+					ha->function_number = 0;
 					ADAPTER_STATE_UNLOCK(ha);
 					ha->flash_nvram_addr = faddr;
-					QL_PRINT_9(CE_CONT, "(%d): nv_rg "
+					QL_PRINT_9(ha, "nv_rg "
 					    "flash_nvram_addr=%xh\n",
 					    ha->instance, faddr);
 				}
-			} else if (!(ha->flags & FUNCTION_1)) {
+			} else if (ha->function_number == 0) {
 				ha->flash_nvram_addr = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_nvram_addr="
-				    "%xh\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_nvram_addr="
+				    "%xh\n", faddr);
 			}
 			break;
 		case FLASH_VPD_1_REGION:
@@ -7192,15 +7530,15 @@
 			if (vpd_rg) {
 				if (vpd_rg == FLASH_VPD_1_REGION) {
 					ha->flash_vpd_addr = faddr;
-					QL_PRINT_9(CE_CONT, "(%d): vpd_rg "
+					QL_PRINT_9(ha, "vpd_rg "
 					    "flash_vpd_addr=%xh\n",
 					    ha->instance, faddr);
 				}
-			} else if (ha->flags & FUNCTION_1 &&
-			    !(CFG_IST(ha, CFG_CTRL_8021))) {
+			} else if (ha->function_number &&
+			    !(CFG_IST(ha, CFG_CTRL_82XX))) {
 				ha->flash_vpd_addr = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_vpd_addr=%xh"
-				    "\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_vpd_addr=%xh"
+				    "\n", faddr);
 			}
 			break;
 		case FLASH_NVRAM_1_REGION:
@@ -7207,38 +7545,38 @@
 			if (nv_rg) {
 				if (nv_rg == FLASH_NVRAM_1_REGION) {
 					ADAPTER_STATE_LOCK(ha);
-					ha->flags |= FUNCTION_1;
+					ha->function_number = 1;
 					ADAPTER_STATE_UNLOCK(ha);
 					ha->flash_nvram_addr = faddr;
-					QL_PRINT_9(CE_CONT, "(%d): nv_rg "
+					QL_PRINT_9(ha, "nv_rg "
 					    "flash_nvram_addr=%xh\n",
 					    ha->instance, faddr);
 				}
-			} else if (ha->flags & FUNCTION_1) {
+			} else if (ha->function_number) {
 				ha->flash_nvram_addr = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_nvram_addr="
-				    "%xh\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_nvram_addr="
+				    "%xh\n", faddr);
 			}
 			break;
 		case FLASH_DESC_TABLE_REGION:
-			if (!(CFG_IST(ha, CFG_CTRL_8021))) {
+			if (!(CFG_IST(ha, CFG_CTRL_82XX))) {
 				ha->flash_desc_addr = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_desc_addr="
-				    "%xh\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_desc_addr="
+				    "%xh\n", faddr);
 			}
 			break;
 		case FLASH_ERROR_LOG_0_REGION:
-			if (!(ha->flags & FUNCTION_1)) {
+			if (ha->function_number == 0) {
 				ha->flash_errlog_start = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_errlog_addr="
-				    "%xh\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_errlog_addr="
+				    "%xh\n", faddr);
 			}
 			break;
 		case FLASH_ERROR_LOG_1_REGION:
-			if (ha->flags & FUNCTION_1) {
+			if (ha->function_number) {
 				ha->flash_errlog_start = faddr;
-				QL_PRINT_9(CE_CONT, "(%d): flash_errlog_addr="
-				    "%xh\n", ha->instance, faddr);
+				QL_PRINT_9(ha, "flash_errlog_addr="
+				    "%xh\n", faddr);
 			}
 			break;
 		default:
@@ -7247,7 +7585,7 @@
 	}
 	kmem_free(bp, FLASH_LAYOUT_TABLE_SIZE);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7266,13 +7604,43 @@
 static void
 ql_flash_nvram_defaults(ql_adapter_state_t *ha)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
-	if (ha->flags & FUNCTION_1) {
-		if (CFG_IST(ha, CFG_CTRL_2300)) {
+	if (ha->function_number == 3) {
+		if (CFG_IST(ha, CFG_CTRL_27XX)) {
+			ha->flash_nvram_addr = NVRAM_2700_FUNC3_ADDR;
+			ha->flash_vpd_addr = VPD_2700_FUNC3_ADDR;
+			ha->ledstate.select = BEACON_2700_FUNC3_ADDR;
+			ha->flash_data_addr = FLASH_2700_DATA_ADDR;
+			ha->flash_desc_addr = FLASH_2700_DESCRIPTOR_TABLE;
+			ha->flash_fw_addr = FLASH_2700_FIRMWARE_ADDR;
+			ha->flash_fw_size = FLASH_2700_FIRMWARE_SIZE;
+			ha->boot_code_addr = FLASH_2700_BOOT_CODE_ADDR;
+		} else {
+			EL(ha, "unassigned flash fn%d addr: %x\n",
+			    ha->function_number, ha->device_id);
+		}
+	} else if (ha->function_number == 2) {
+		if (CFG_IST(ha, CFG_CTRL_27XX)) {
+			ha->flash_nvram_addr = NVRAM_2700_FUNC2_ADDR;
+			ha->flash_vpd_addr = VPD_2700_FUNC2_ADDR;
+			ha->ledstate.select = BEACON_2700_FUNC2_ADDR;
+			ha->flash_data_addr = FLASH_2700_DATA_ADDR;
+			ha->flash_desc_addr = FLASH_2700_DESCRIPTOR_TABLE;
+			ha->flash_fw_addr = FLASH_2700_FIRMWARE_ADDR;
+			ha->flash_fw_size = FLASH_2700_FIRMWARE_SIZE;
+			ha->boot_code_addr = FLASH_2700_BOOT_CODE_ADDR;
+		} else {
+			EL(ha, "unassigned flash fn%d addr: %x\n",
+			    ha->function_number, ha->device_id);
+		}
+	} else if (ha->function_number == 1) {
+		if (CFG_IST(ha, CFG_CTRL_23XX) ||
+		    (CFG_IST(ha, CFG_CTRL_63XX))) {
 			ha->flash_nvram_addr = NVRAM_2300_FUNC1_ADDR;
 			ha->flash_fw_addr = FLASH_2300_FIRMWARE_ADDR;
-		} else if (CFG_IST(ha, CFG_CTRL_2422)) {
+			ha->boot_code_addr = FLASH_2300_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_24XX)) {
 			ha->flash_data_addr = FLASH_24_25_DATA_ADDR;
 			ha->flash_nvram_addr = NVRAM_2400_FUNC1_ADDR;
 			ha->flash_vpd_addr = VPD_2400_FUNC1_ADDR;
@@ -7279,6 +7647,7 @@
 			ha->flash_errlog_start = FLASH_2400_ERRLOG_START_ADDR_1;
 			ha->flash_desc_addr = FLASH_2400_DESCRIPTOR_TABLE;
 			ha->flash_fw_addr = FLASH_2400_FIRMWARE_ADDR;
+			ha->boot_code_addr = FLASH_2400_BOOT_CODE_ADDR;
 		} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
 			ha->flash_data_addr = FLASH_24_25_DATA_ADDR;
 			ha->flash_nvram_addr = NVRAM_2500_FUNC1_ADDR;
@@ -7286,6 +7655,7 @@
 			ha->flash_errlog_start = FLASH_2500_ERRLOG_START_ADDR_1;
 			ha->flash_desc_addr = FLASH_2500_DESCRIPTOR_TABLE;
 			ha->flash_fw_addr = FLASH_2500_FIRMWARE_ADDR;
+			ha->boot_code_addr = FLASH_2500_BOOT_CODE_ADDR;
 		} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
 			ha->flash_data_addr = FLASH_8100_DATA_ADDR;
 			ha->flash_nvram_addr = NVRAM_8100_FUNC1_ADDR;
@@ -7293,7 +7663,8 @@
 			ha->flash_errlog_start = FLASH_8100_ERRLOG_START_ADDR_1;
 			ha->flash_desc_addr = FLASH_8100_DESCRIPTOR_TABLE;
 			ha->flash_fw_addr = FLASH_8100_FIRMWARE_ADDR;
-		} else if (CFG_IST(ha, CFG_CTRL_8021)) {
+			ha->boot_code_addr = FLASH_8100_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
 			ha->flash_data_addr = 0;
 			ha->flash_nvram_addr = NVRAM_8021_FUNC1_ADDR;
 			ha->flash_vpd_addr = VPD_8021_FUNC1_ADDR;
@@ -7303,16 +7674,43 @@
 			ha->flash_fw_size = FLASH_8021_FIRMWARE_SIZE;
 			ha->bootloader_addr = FLASH_8021_BOOTLOADER_ADDR;
 			ha->bootloader_size = FLASH_8021_BOOTLOADER_SIZE;
+			ha->boot_code_addr = FLASH_8021_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+			ha->flash_nvram_addr = NVRAM_8300_FC_FUNC1_ADDR;
+			ha->flash_vpd_addr = VPD_8300_FC_FUNC1_ADDR;
+			ha->ledstate.select = BEACON_8300_FC_FUNC1_ADDR;
+			ha->flash_errlog_start = FLASH_8300_ERRLOG_START_ADDR_1;
+			ha->flash_data_addr = FLASH_8300_DATA_ADDR;
+			ha->flash_desc_addr = FLASH_8300_DESCRIPTOR_TABLE;
+			ha->flash_fw_addr = FLASH_8300_FC_FIRMWARE_ADDR;
+			ha->flash_fw_size = FLASH_8300_FIRMWARE_SIZE;
+			ha->bootloader_addr = FLASH_8300_BOOTLOADER_ADDR;
+			ha->bootloader_size = FLASH_8300_BOOTLOADER_SIZE;
+			ha->boot_code_addr = FLASH_8300_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_27XX)) {
+			ha->flash_nvram_addr = NVRAM_2700_FUNC1_ADDR;
+			ha->flash_vpd_addr = VPD_2700_FUNC1_ADDR;
+			ha->ledstate.select = BEACON_2700_FUNC1_ADDR;
+			ha->flash_data_addr = FLASH_2700_DATA_ADDR;
+			ha->flash_desc_addr = FLASH_2700_DESCRIPTOR_TABLE;
+			ha->flash_fw_addr = FLASH_2700_FIRMWARE_ADDR;
+			ha->flash_fw_size = FLASH_2700_FIRMWARE_SIZE;
+			ha->boot_code_addr = FLASH_2700_BOOT_CODE_ADDR;
+		} else {
+			EL(ha, "unassigned flash fn%d addr: %x\n",
+			    ha->function_number, ha->device_id);
 		}
-	} else {
-		if (CFG_IST(ha, CFG_CTRL_2200)) {
+	} else if (ha->function_number == 0) {
+		if (CFG_IST(ha, CFG_CTRL_22XX)) {
 			ha->flash_nvram_addr = NVRAM_2200_FUNC0_ADDR;
 			ha->flash_fw_addr = FLASH_2200_FIRMWARE_ADDR;
-		} else if (CFG_IST(ha, CFG_CTRL_2300) ||
-		    (CFG_IST(ha, CFG_CTRL_6322))) {
+			ha->boot_code_addr = FLASH_2200_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_23XX) ||
+		    (CFG_IST(ha, CFG_CTRL_63XX))) {
 			ha->flash_nvram_addr = NVRAM_2300_FUNC0_ADDR;
 			ha->flash_fw_addr = FLASH_2300_FIRMWARE_ADDR;
-		} else if (CFG_IST(ha, CFG_CTRL_2422)) {
+			ha->boot_code_addr = FLASH_2300_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_24XX)) {
 			ha->flash_data_addr = FLASH_24_25_DATA_ADDR;
 			ha->flash_nvram_addr = NVRAM_2400_FUNC0_ADDR;
 			ha->flash_vpd_addr = VPD_2400_FUNC0_ADDR;
@@ -7319,6 +7717,7 @@
 			ha->flash_errlog_start = FLASH_2400_ERRLOG_START_ADDR_0;
 			ha->flash_desc_addr = FLASH_2400_DESCRIPTOR_TABLE;
 			ha->flash_fw_addr = FLASH_2400_FIRMWARE_ADDR;
+			ha->boot_code_addr = FLASH_2400_BOOT_CODE_ADDR;
 		} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
 			ha->flash_data_addr = FLASH_24_25_DATA_ADDR;
 			ha->flash_nvram_addr = NVRAM_2500_FUNC0_ADDR;
@@ -7326,6 +7725,7 @@
 			ha->flash_errlog_start = FLASH_2500_ERRLOG_START_ADDR_0;
 			ha->flash_desc_addr = FLASH_2500_DESCRIPTOR_TABLE;
 			ha->flash_fw_addr = FLASH_2500_FIRMWARE_ADDR;
+			ha->boot_code_addr = FLASH_2500_BOOT_CODE_ADDR;
 		} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
 			ha->flash_data_addr = FLASH_8100_DATA_ADDR;
 			ha->flash_nvram_addr = NVRAM_8100_FUNC0_ADDR;
@@ -7333,7 +7733,8 @@
 			ha->flash_errlog_start = FLASH_8100_ERRLOG_START_ADDR_0;
 			ha->flash_desc_addr = FLASH_8100_DESCRIPTOR_TABLE;
 			ha->flash_fw_addr = FLASH_8100_FIRMWARE_ADDR;
-		} else if (CFG_IST(ha, CFG_CTRL_8021)) {
+			ha->boot_code_addr = FLASH_8100_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
 			ha->flash_data_addr = 0;
 			ha->flash_nvram_addr = NVRAM_8021_FUNC0_ADDR;
 			ha->flash_vpd_addr = VPD_8021_FUNC0_ADDR;
@@ -7343,12 +7744,37 @@
 			ha->flash_fw_size = FLASH_8021_FIRMWARE_SIZE;
 			ha->bootloader_addr = FLASH_8021_BOOTLOADER_ADDR;
 			ha->bootloader_size = FLASH_8021_BOOTLOADER_SIZE;
+			ha->boot_code_addr = FLASH_8021_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+			ha->flash_nvram_addr = NVRAM_8300_FC_FUNC0_ADDR;
+			ha->flash_vpd_addr = VPD_8300_FC_FUNC0_ADDR;
+			ha->ledstate.select = BEACON_8300_FCOE_FUNC0_ADDR;
+			ha->flash_errlog_start = FLASH_8300_ERRLOG_START_ADDR_0;
+			ha->flash_data_addr = FLASH_8300_DATA_ADDR;
+			ha->flash_desc_addr = FLASH_8300_DESCRIPTOR_TABLE;
+			ha->flash_fw_addr = FLASH_8300_FC_FIRMWARE_ADDR;
+			ha->flash_fw_size = FLASH_8300_FIRMWARE_SIZE;
+			ha->bootloader_addr = FLASH_8300_BOOTLOADER_ADDR;
+			ha->bootloader_size = FLASH_8300_BOOTLOADER_SIZE;
+			ha->boot_code_addr = FLASH_8300_BOOT_CODE_ADDR;
+		} else if (CFG_IST(ha, CFG_CTRL_27XX)) {
+			ha->flash_nvram_addr = NVRAM_2700_FUNC0_ADDR;
+			ha->flash_vpd_addr = VPD_2700_FUNC0_ADDR;
+			ha->ledstate.select = BEACON_2700_FUNC0_ADDR;
+			ha->flash_data_addr = FLASH_2700_DATA_ADDR;
+			ha->flash_desc_addr = FLASH_2700_DESCRIPTOR_TABLE;
+			ha->flash_fw_addr = FLASH_2700_FIRMWARE_ADDR;
+			ha->flash_fw_size = FLASH_2700_FIRMWARE_SIZE;
+			ha->boot_code_addr = FLASH_2700_BOOT_CODE_ADDR;
 		} else {
-			EL(ha, "unassigned flash fn0 addr: %x\n",
-			    ha->device_id);
+			EL(ha, "unassigned flash fn%d addr: %x\n",
+			    ha->function_number, ha->device_id);
 		}
+	} else {
+		EL(ha, "known function=%d, device_id=%x\n",
+		    ha->function_number, ha->device_id);
 	}
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_10(ha, "done\n");
 }
 
 /*
@@ -7369,9 +7795,9 @@
 static void
 ql_get_sfp(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if ((CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		EL(ha, "failed, invalid request for HBA\n");
 		return;
@@ -7394,7 +7820,7 @@
 		cmd->Status = EXT_STATUS_OK;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7419,7 +7845,7 @@
 	int		rval2, rval = 0;
 	uint32_t	dxfer;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Get memory for SFP. */
 
@@ -7454,7 +7880,7 @@
 
 	ql_free_phys(ha, &mem);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -7484,9 +7910,9 @@
 	uint32_t		rval = QL_SUCCESS;
 	uint32_t		idma_rate;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_242581) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		EL(ha, "invalid request for this HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
@@ -7518,12 +7944,13 @@
 
 	name = port_param.FCScsiAddr.DestAddr.WWPN;
 
-	QL_PRINT_9(CE_CONT, "(%d): wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+	QL_PRINT_9(ha, "wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
 	    ha->instance, name[0], name[1], name[2], name[3], name[4],
 	    name[5], name[6], name[7]);
 
 	tq = ql_find_port(ha, name, (uint16_t)QLNT_PORT);
-	if (tq == NULL || !VALID_TARGET_ID(ha, tq->loop_id)) {
+	if (tq == NULL || !VALID_TARGET_ID(ha, tq->loop_id) ||
+	    tq->d_id.b24 == FS_MANAGEMENT_SERVER) {
 		EL(ha, "failed, fc_port not found\n");
 		cmd->Status = EXT_STATUS_DEV_NOT_FOUND;
 		cmd->ResponseLen = 0;
@@ -7568,6 +7995,14 @@
 				port_param.Speed =
 				    EXT_DEF_PORTSPEED_10GBIT;
 				break;
+			case IIDMA_RATE_16GB:
+				port_param.Speed =
+				    EXT_DEF_PORTSPEED_16GBIT;
+				break;
+			case IIDMA_RATE_32GB:
+				port_param.Speed =
+				    EXT_DEF_PORTSPEED_32GBIT;
+				break;
 			default:
 				port_param.Speed =
 				    EXT_DEF_PORTSPEED_UNKNOWN;
@@ -7610,8 +8045,14 @@
 			idma_rate = IIDMA_RATE_8GB;
 			break;
 		case EXT_DEF_PORTSPEED_10GBIT:
-			port_param.Speed = IIDMA_RATE_10GB;
+			idma_rate = IIDMA_RATE_10GB;
 			break;
+		case EXT_DEF_PORTSPEED_16GBIT:
+			idma_rate = IIDMA_RATE_16GB;
+			break;
+		case EXT_DEF_PORTSPEED_32GBIT:
+			idma_rate = IIDMA_RATE_32GB;
+			break;
 		default:
 			EL(ha, "invalid set iidma rate: %x\n",
 			    port_param.Speed);
@@ -7640,7 +8081,7 @@
 		break;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7664,9 +8105,9 @@
 	int	rval;
 	caddr_t	payload;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_24258081) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		EL(ha, "invalid request for this HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
@@ -7691,7 +8132,8 @@
 	}
 
 	/* Time Stamp */
-	rval = ql_fw_etrace(ha, &ha->fwexttracebuf, FTO_INSERT_TIME_STAMP);
+	rval = ql_fw_etrace(ha, &ha->fwexttracebuf, FTO_INSERT_TIME_STAMP,
+	    NULL);
 	if (rval != QL_SUCCESS) {
 		EL(ha, "f/w extended trace insert"
 		    "time stamp failed: %xh\n", rval);
@@ -7701,7 +8143,8 @@
 	}
 
 	/* Disable Tracing */
-	rval = ql_fw_etrace(ha, &ha->fwexttracebuf, FTO_EXT_TRACE_DISABLE);
+	rval = ql_fw_etrace(ha, &ha->fwexttracebuf, FTO_EXT_TRACE_DISABLE,
+	    NULL);
 	if (rval != QL_SUCCESS) {
 		EL(ha, "f/w extended trace disable failed: %xh\n", rval);
 		cmd->Status = EXT_STATUS_ERR;
@@ -7739,7 +8182,7 @@
 
 	kmem_free(payload, FWEXTSIZE);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7760,12 +8203,16 @@
 static void
 ql_get_fwfcetrace(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	int	rval;
-	caddr_t	payload;
+	int			rval;
+	caddr_t			fce_trace_p;
+	ql_mbx_data_t		mr;
+	EXT_FW_FCE_TRACE	*fce_trace;
+	size_t			cnt;
+	uint32_t		*bp;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_24258081) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		EL(ha, "invalid request for this HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
@@ -7790,7 +8237,7 @@
 	}
 
 	/* Disable Tracing */
-	rval = ql_fw_etrace(ha, &ha->fwfcetracebuf, FTO_FCE_TRACE_DISABLE);
+	rval = ql_fw_etrace(ha, &ha->fwfcetracebuf, FTO_FCE_TRACE_DISABLE, &mr);
 	if (rval != QL_SUCCESS) {
 		EL(ha, "f/w FCE trace disable failed: %xh\n", rval);
 		cmd->Status = EXT_STATUS_ERR;
@@ -7799,25 +8246,53 @@
 	}
 
 	/* Allocate payload buffer */
-	payload = kmem_zalloc(FWEXTSIZE, KM_SLEEP);
-	if (payload == NULL) {
+	fce_trace = kmem_zalloc(FWFCESIZE, KM_SLEEP);
+	if (fce_trace == NULL) {
 		EL(ha, "failed, kmem_zalloc\n");
 		cmd->Status = EXT_STATUS_NO_MEMORY;
 		cmd->ResponseLen = 0;
 		return;
 	}
+	fce_trace_p = (caddr_t)&fce_trace->TraceData[0];
 
+	/* Copy In Ponter and Base Pointer values */
+	fce_trace->Registers[0] = mr.mb[2];
+	fce_trace->Registers[1] = mr.mb[3];
+	fce_trace->Registers[2] = mr.mb[4];
+	fce_trace->Registers[3] = mr.mb[5];
+
+	fce_trace->Registers[4] = LSW(ha->fwexttracebuf.cookies->dmac_address);
+	fce_trace->Registers[5] = MSW(ha->fwexttracebuf.cookies->dmac_address);
+	fce_trace->Registers[6] = LSW(ha->fwexttracebuf.cookies->dmac_notused);
+	fce_trace->Registers[7] = MSW(ha->fwexttracebuf.cookies->dmac_notused);
+
+	/* Copy FCE Trace Enable Registers */
+	fce_trace->Registers[8] = ha->fw_fce_trace_enable.mb[0];
+	fce_trace->Registers[9] = ha->fw_fce_trace_enable.mb[2];
+	fce_trace->Registers[10] = ha->fw_fce_trace_enable.mb[3];
+	fce_trace->Registers[11] = ha->fw_fce_trace_enable.mb[4];
+	fce_trace->Registers[12] = ha->fw_fce_trace_enable.mb[5];
+	fce_trace->Registers[13] = ha->fw_fce_trace_enable.mb[6];
+
 	/* Sync DMA buffer. */
 	(void) ddi_dma_sync(ha->fwfcetracebuf.dma_handle, 0,
 	    FWFCESIZE, DDI_DMA_SYNC_FORKERNEL);
 
 	/* Copy trace buffer data. */
-	ddi_rep_get8(ha->fwfcetracebuf.acc_handle, (uint8_t *)payload,
+	ddi_rep_get8(ha->fwfcetracebuf.acc_handle, (uint8_t *)fce_trace_p,
 	    (uint8_t *)ha->fwfcetracebuf.bp, FWFCESIZE,
 	    DDI_DEV_AUTOINCR);
 
+	/* Swap bytes in buffer in case of Big Endian */
+	bp = (uint32_t *)&fce_trace->TraceData[0];
+	for (cnt = 0; cnt < (FWFCESIZE / sizeof (uint32_t)); cnt++) {
+		LITTLE_ENDIAN_32(bp);
+		bp++;
+	}
+
 	/* Send payload to application. */
-	if (ql_send_buffer_data(payload, (caddr_t)(uintptr_t)cmd->ResponseAdr,
+	if (ql_send_buffer_data((caddr_t)fce_trace,
+	    (caddr_t)(uintptr_t)cmd->ResponseAdr,
 	    cmd->ResponseLen, mode) != cmd->ResponseLen) {
 		EL(ha, "failed, send_buffer_data\n");
 		cmd->Status = EXT_STATUS_COPY_ERR;
@@ -7826,9 +8301,19 @@
 		cmd->Status = EXT_STATUS_OK;
 	}
 
-	kmem_free(payload, FWFCESIZE);
+	/* Re-enable Tracing */
+	bzero(ha->fwfcetracebuf.bp, ha->fwfcetracebuf.size);
+	if ((rval = ql_fw_etrace(ha, &ha->fwfcetracebuf,
+	    FTO_FCE_TRACE_ENABLE, &mr)) != QL_SUCCESS) {
+		EL(ha, "fcetrace enable failed: %xh\n", rval);
+	} else {
+		ha->fw_fce_trace_enable = mr;
+		EL(ha, "FCE Trace Re-Enabled\n");
+	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	kmem_free(fce_trace, FWFCESIZE);
+
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7854,7 +8339,7 @@
 	uint8_t		cap_id;
 	uint32_t	buf_size = 256;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/*
 	 * First check the "Capabilities List" bit of the status register.
@@ -7897,7 +8382,7 @@
 		cmd->DetailStatus = buf_size;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7919,7 +8404,7 @@
 	uint32_t	pci_os;
 	uint32_t	*ptr32, *org_ptr32;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	ptr32 = kmem_zalloc(pci_size, KM_SLEEP);
 	if (ptr32 == NULL) {
@@ -7946,7 +8431,7 @@
 
 	kmem_free(org_ptr32, pci_size);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (0);
 }
@@ -7972,7 +8457,7 @@
 	ql_mbx_data_t	mr;
 	int		rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if ((CFG_IST(ha, CFG_CTRL_MENLO)) == 0) {
 		EL(ha, "failed, invalid request for HBA\n");
@@ -8029,7 +8514,7 @@
 
 	ql_restart_hba(ha);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8053,7 +8538,7 @@
 	ql_mbx_iocb_t			*pkt;
 	EXT_MENLO_GET_FW_VERSION	ver = {0};
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if ((CFG_IST(ha, CFG_CTRL_MENLO)) == 0) {
 		EL(ha, "failed, invalid request for HBA\n");
@@ -8111,7 +8596,7 @@
 
 	kmem_free(pkt, sizeof (ql_mbx_iocb_t));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8137,7 +8622,7 @@
 	uint32_t		*ptr32;
 	int			rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if ((CFG_IST(ha, CFG_CTRL_MENLO)) == 0) {
 		EL(ha, "failed, invalid request for HBA\n");
@@ -8200,8 +8685,8 @@
 	/* Get DMA memory for the IOCB */
 	if (ql_get_dma_mem(ha, dma_mem, fw.TotalByteCount, LITTLE_ENDIAN_DMA,
 	    QL_DMA_DATA_ALIGN) != QL_SUCCESS) {
-		cmn_err(CE_WARN, "%s(%d): request queue DMA memory "
-		    "alloc failed", QL_NAME, ha->instance);
+		cmn_err(CE_WARN, "%srequest queue DMA memory "
+		    "alloc failed", QL_NAME);
 		kmem_free(pkt, sizeof (ql_mbx_iocb_t));
 		kmem_free(dma_mem, sizeof (dma_mem_t));
 		ql_restart_hba(ha);
@@ -8235,11 +8720,11 @@
 	pkt->mvfy.fw_size = LE_32(fw.TotalByteCount);
 	pkt->mvfy.fw_sequence_size = LE_32(fw.TotalByteCount);
 	pkt->mvfy.dseg_count = LE_16(1);
-	pkt->mvfy.dseg_0_address[0] = (uint32_t)
+	pkt->mvfy.dseg.address[0] = (uint32_t)
 	    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-	pkt->mvfy.dseg_0_address[1] = (uint32_t)
+	pkt->mvfy.dseg.address[1] = (uint32_t)
 	    LE_32(MSD(dma_mem->cookie.dmac_laddress));
-	pkt->mvfy.dseg_0_length = LE_32(fw.TotalByteCount);
+	pkt->mvfy.dseg.length = LE_32(fw.TotalByteCount);
 
 	rval = ql_issue_mbx_iocb(ha, (caddr_t)pkt, sizeof (ql_mbx_iocb_t));
 	LITTLE_ENDIAN_16(&pkt->mvfy.options_status);
@@ -8262,7 +8747,7 @@
 	kmem_free(dma_mem, sizeof (dma_mem_t));
 	ql_restart_hba(ha);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8287,18 +8772,17 @@
 	EXT_MENLO_MANAGE_INFO	info;
 	int			rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 
 	/* The call is only supported for Schultz right now */
-	if (CFG_IST(ha, CFG_CTRL_8081)) {
+	if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
 		ql_get_xgmac_statistics(ha, cmd, mode);
-		QL_PRINT_9(CE_CONT, "(%d): CFG_CTRL_81XX done\n",
-		    ha->instance);
+		QL_PRINT_9(ha, "CFG_FCOE_SUPPORT done\n");
 		return;
 	}
 
-	if (!CFG_IST(ha, CFG_CTRL_8081) || !CFG_IST(ha, CFG_CTRL_MENLO)) {
+	if (!CFG_IST(ha, CFG_CTRL_MENLO)) {
 		EL(ha, "failed, invalid request for HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
@@ -8356,8 +8840,8 @@
 		}
 		if (ql_get_dma_mem(ha, dma_mem, info.TotalByteCount,
 		    LITTLE_ENDIAN_DMA, QL_DMA_DATA_ALIGN) != QL_SUCCESS) {
-			cmn_err(CE_WARN, "%s(%d): request queue DMA memory "
-			    "alloc failed", QL_NAME, ha->instance);
+			cmn_err(CE_WARN, "%srequest queue DMA memory "
+			    "alloc failed", QL_NAME);
 			kmem_free(dma_mem, sizeof (dma_mem_t));
 			kmem_free(pkt, sizeof (ql_mbx_iocb_t));
 			cmd->Status = EXT_STATUS_MS_NO_RESPONSE;
@@ -8382,11 +8866,11 @@
 			    dma_mem->size, DDI_DMA_SYNC_FORDEV);
 		}
 		pkt->mdata.dseg_count = LE_16(1);
-		pkt->mdata.dseg_0_address[0] = (uint32_t)
+		pkt->mdata.dseg.address[0] = (uint32_t)
 		    LE_32(LSD(dma_mem->cookie.dmac_laddress));
-		pkt->mdata.dseg_0_address[1] = (uint32_t)
+		pkt->mdata.dseg.address[1] = (uint32_t)
 		    LE_32(MSD(dma_mem->cookie.dmac_laddress));
-		pkt->mdata.dseg_0_length = LE_32(info.TotalByteCount);
+		pkt->mdata.dseg.length = LE_32(info.TotalByteCount);
 	} else if (info.Operation & MENLO_OP_CHANGE_CONFIG) {
 		pkt->mdata.parameter_1 =
 		    LE_32(info.Parameters.ap.MenloConfig.ConfigParamID);
@@ -8430,7 +8914,7 @@
 	kmem_free(dma_mem, sizeof (dma_mem_t));
 	kmem_free(pkt, sizeof (ql_mbx_iocb_t));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8525,7 +9009,7 @@
 	int			rval;
 	char			name[MAXPATHLEN];
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/*
 	 * To be backward compatible with older API
@@ -8553,7 +9037,8 @@
 		ptmp_vp->VpCnt++;
 		ptmp_vp->VpId[id] = vha->vp_index;
 		(void) ddi_pathname(vha->dip, name);
-		(void) strcpy((char *)ptmp_vp->vp_path[id], name);
+		(void) strncpy((char *)ptmp_vp->vp_path[id], name,
+		    (sizeof (ptmp_vp->vp_path[id]) -1));
 		ptmp_vp->VpDrvInst[id] = (int32_t)vha->instance;
 		id++;
 		vha = vha->vp_next;
@@ -8567,10 +9052,10 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_VPORT_ID_CNT);
-		QL_PRINT_9(CE_CONT, "(%d): done, vport_cnt=%d\n",
+		QL_PRINT_9(ha, "done, vport_cnt=%d\n",
 		    ha->instance, ptmp_vp->VpCnt);
 	}
-
+	kmem_free(ptmp_vp, sizeof (EXT_VPORT_ID_CNT));
 }
 
 /*
@@ -8591,7 +9076,7 @@
 static void
 ql_vp_ioctl(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started, cmd=%d\n", ha->instance,
+	QL_PRINT_9(ha, "started, cmd=%d\n",
 	    cmd->SubCode);
 
 	/* case off on command subcode */
@@ -8607,7 +9092,7 @@
 		break;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8630,9 +9115,8 @@
 {
 	ql_adapter_state_t	*tmp_vha;
 	EXT_VPORT_INFO		tmp_vport = {0};
-	int			max_vport;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", vha->instance);
+	QL_PRINT_9(vha, "started\n", vha->instance);
 
 	if (cmd->ResponseLen < sizeof (EXT_VPORT_INFO)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -8657,10 +9141,8 @@
 		tmp_vha = tmp_vha->vp_next;
 	}
 
-	max_vport = (CFG_IST(vha, CFG_CTRL_2422) ? MAX_24_VIRTUAL_PORTS :
-	    MAX_25_VIRTUAL_PORTS);
-	if (max_vport > tmp_vport.used) {
-		tmp_vport.free = max_vport - tmp_vport.used;
+	if (vha->max_vports > tmp_vport.used) {
+		tmp_vport.free = vha->max_vports - tmp_vport.used;
 	}
 
 	if (ddi_copyout((void *)&tmp_vport,
@@ -8671,7 +9153,7 @@
 		EL(vha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (EXT_VPORT_INFO);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", vha->instance);
+		QL_PRINT_9(vha, "done\n", vha->instance);
 	}
 }
 
@@ -8695,8 +9177,17 @@
 {
 	int	rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1) &&
+	    ql_stall_driver(ha, 0) != QL_SUCCESS) {
+		EL(ha, "ql_stall_driver failed\n");
+		ql_restart_driver(ha);
+		cmd->Status = EXT_STATUS_BUSY;
+		cmd->ResponseLen = 0;
+		return;
+	}
+
 	switch (cmd->SubCode) {
 	case EXT_SC_FLASH_READ:
 		if ((rval = ql_flash_fcode_dump(ha,
@@ -8727,7 +9218,14 @@
 		break;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	/* Resume I/O */
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
+		EL(ha, "isp_abort_needed for restart\n");
+		ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED,
+		    DRIVER_STALL);
+	}
+
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8747,19 +9245,39 @@
 static void
 ql_reset_cmd(ql_adapter_state_t *ha, EXT_IOCTL *cmd)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	uint8_t	timer;
 
+	QL_PRINT_9(ha, "started\n");
+
 	switch (cmd->SubCode) {
 	case EXT_SC_RESET_FC_FW:
-		EL(ha, "isp_abort_needed\n");
-		ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED, 0);
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
+			(void) ql_8021_reset_fw(ha);
+		} else {
+			EL(ha, "isp_abort_needed\n");
+			ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED, 0);
+		}
+		for (timer = 180; timer; timer--) {
+			ql_awaken_task_daemon(ha, NULL, 0, 0);
+			/* Delay for 1 second. */
+			delay(100);
+			if (!(ha->task_daemon_flags & (ISP_ABORT_NEEDED |
+			    ABORT_ISP_ACTIVE | LOOP_RESYNC_NEEDED |
+			    LOOP_RESYNC_ACTIVE))) {
+				break;
+			}
+		}
 		break;
 	case EXT_SC_RESET_MPI_FW:
-		if (!(CFG_IST(ha, CFG_CTRL_81XX))) {
+		if (!(CFG_IST(ha, CFG_CTRL_8081))) {
 			EL(ha, "invalid request for HBA\n");
 			cmd->Status = EXT_STATUS_INVALID_REQUEST;
 			cmd->ResponseLen = 0;
 		} else {
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags |= DISABLE_NIC_FW_DMP;
+			ADAPTER_STATE_UNLOCK(ha);
+
 			/* Wait for I/O to stop and daemon to stall. */
 			if (ql_suspend_hba(ha, 0) != QL_SUCCESS) {
 				EL(ha, "ql_suspend_hba failed\n");
@@ -8769,7 +9287,6 @@
 				cmd->Status = EXT_STATUS_ERR;
 				cmd->ResponseLen = 0;
 			} else {
-				uint8_t	timer;
 				/*
 				 * While the restart_mpi mailbox cmd may be
 				 * done the MPI is not. Wait at least 6 sec. or
@@ -8785,6 +9302,10 @@
 				}
 			}
 			ql_restart_hba(ha);
+
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags &= ~DISABLE_NIC_FW_DMP;
+			ADAPTER_STATE_UNLOCK(ha);
 		}
 		break;
 	default:
@@ -8794,7 +9315,7 @@
 		break;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -8812,9 +9333,9 @@
 	uint8_t		*tmp_buf;
 	int		rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (!(CFG_IST(ha, CFG_CTRL_8081))) {
+	if (!(CFG_IST(ha, CFG_FCOE_SUPPORT))) {
 		EL(ha, "invalid request for HBA\n");
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		cmd->ResponseLen = 0;
